/* the cantus project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/cantus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include "support.h"

#include "freedb.h"
#include "lib_freedb.h"
#include "gui_freedb.h"
#include "mp3info.h"

void
clist_album_choose_albums_add (GList *cdlist)
{
	extern GtkWidget *tracks_sort;
	
	CDInfo *cd = NULL;
	GList *listitem = NULL;
	gchar *row[3];
	
	listitem = g_list_first(cdlist);
	while(listitem)
	{
		cd = (CDInfo *)listitem->data;
		row[0] = cd->cdtitle;
		row[1] = cd->genre;
		row[2] = malloc(9);
		snprintf(row[2], 9, "%08lx", cd->id);
		
		gtk_clist_set_row_data(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_cdlist")),
			gtk_clist_append(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_cdlist")), row),
			cd);
		
		g_free(row[2]);
		listitem = listitem->next;
	}
	
// cleanup
	gtk_clist_sort(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_cdlist")));
	gtk_clist_columns_autosize(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_cdlist")));
	return;
}



void
clist_tracks_sort_tracks_add(CDInfo *cd)
{
	extern GtkWidget *tracks_sort;
	gchar *rowdata[4];
	gint row = 0;

	gtk_clist_clear(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks")));
	
	row = -1;
	while( cd->track[++row] )
	{
		CDTrack *track = (CDTrack *)cd->track[row];
		
		rowdata[0] = track->filename;
		rowdata[1] = strdup("->");
		rowdata[2] = malloc(5);
		snprintf(rowdata[2], 4, "%i", row + 1);
		rowdata[3] = track->title;
		
// insert the data in the list
		gtk_clist_set_row_data(
			GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks")),
			gtk_clist_append(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks")), rowdata), cd );

		g_free(rowdata[1]);
		g_free(rowdata[2]);
	}
	
	gtk_clist_columns_autosize(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks")));
}












void
clist_tracks_move_track_down (void)
{
	extern GtkWidget *tracks_sort;
	GtkCList *clist = NULL;
	GList *selection = NULL;
	gchar *foo = NULL;
	gint row = -1;
	gboolean stopit = FALSE;
	gchar temp[2048];
	gchar track[20];
	CDInfo *cd = NULL;
	gchar title[2048] = "";
	gchar number[20] = "";

	clist = GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks"));
// count rows in clist
	while(gtk_clist_get_text (clist, ++row, 2, &foo));
		
	cd = (CDInfo*)gtk_clist_get_row_data (clist, 0);

// and toggle swap each selected item with its followed one (if one is present)
	while (row >= 0)
	{
		selection = clist->selection;
		while (selection)
		{
			if((gint)selection->data==row)
			{
				if(gtk_clist_get_text (clist, row+1, 2, &foo))
				{
// Swap rows in the CD struct
					strncpy (title, ((CDTrack*)cd->track[row])->title, 2047);
					strncpy (number, ((CDTrack*)cd->track[row])->number, 19);
					strncpy (((CDTrack*)cd->track[row])->title, ((CDTrack*)cd->track[row + 1])->title, 2047);
					strncpy (((CDTrack*)cd->track[row])->number, ((CDTrack*)cd->track[row + 1])->number, 19);
					strncpy (((CDTrack*)cd->track[row + 1])->title, title, 2047);
					strncpy (((CDTrack*)cd->track[row + 1])->number, number, 19);
					
// Swap rows in the GUI
					gtk_clist_get_text (clist, row, 2, &foo);
					strncpy(track, foo, 2047);
					gtk_clist_get_text (clist, row, 3, &foo);
					strncpy(temp, foo, 2047);
					
					gtk_clist_get_text (clist, row+1, 2, &foo);
					gtk_clist_set_text(clist, row, 2, foo);
					gtk_clist_get_text (clist, row+1, 3, &foo);
					gtk_clist_set_text(clist, row, 3, foo);
					
					gtk_clist_set_text(clist, row+1, 2, track);
					gtk_clist_set_text(clist, row+1, 3, temp);
					
					gtk_clist_unselect_row(clist, row, 2);
					gtk_clist_select_row(clist, row+1, 2);
				}
				else
					stopit=TRUE;
				break;
			}
			selection = selection->next;
		}
		if(stopit) break;
		--row;
	}
}
















void
clist_tracks_move_track_up(void)
{
	extern GtkWidget *tracks_sort;
	GtkCList *clist = NULL;
	GList *selection = NULL;
	gchar *foo = NULL;
	gint row = -1;
	gboolean stopit = FALSE;
	gchar temp[2048];
	gchar track[20];
	gint max = -1;
	CDInfo *cd = NULL;
	gchar title[2048] = "";
	gchar number[20] = "";

	clist = GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks"));
// count rows	
	while(gtk_clist_get_text (clist, ++max, 2, &foo));

	cd = (CDInfo*)gtk_clist_get_row_data (clist, 0);

// swap each selected item with the previous one (if present)
	while ( row < max )
	{
		selection = clist->selection;
		while (selection)
		{
			if ( (gint)selection->data == row )
			{
				if(gtk_clist_get_text (clist, row - 1, 2, &foo))
				{
// Swap rows in the CD struct
					strncpy (title, ((CDTrack*)cd->track[row])->title, 2047);
					strncpy (number, ((CDTrack*)cd->track[row])->number, 19);
					strncpy (((CDTrack*)cd->track[row])->title, ((CDTrack*)cd->track[row - 1])->title, 2047);
					strncpy (((CDTrack*)cd->track[row])->number, ((CDTrack*)cd->track[row - 1])->number, 19);
					strncpy (((CDTrack*)cd->track[row - 1])->title, title, 2047);
					strncpy (((CDTrack*)cd->track[row - 1])->number, number, 19);
					
// Swap rows in the GUI
					gtk_clist_get_text (clist, row, 2, &foo);
					strncpy(track, foo, 2047);
					gtk_clist_get_text (clist, row, 3, &foo);
					strncpy(temp, foo, 2047);
					
					gtk_clist_get_text (clist, row-1, 2, &foo);
					gtk_clist_set_text(clist, row, 2, foo);
					gtk_clist_get_text (clist, row-1, 3, &foo);
					gtk_clist_set_text(clist, row, 3, foo);
					
					gtk_clist_set_text(clist, row-1, 2, track);
					gtk_clist_set_text(clist, row-1, 3, temp);
					
					gtk_clist_unselect_row(clist, row, 2);
					gtk_clist_select_row(clist, row-1, 2);
				}
				else
					stopit=TRUE;
				break;
			}
			selection = selection->next;
		}
		if(stopit) break;
		++row;
	}
}

